<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ByteBufferInputStream.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">ByteBufferInputStream.java</span></div><h1>ByteBufferInputStream.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.Record;

public class ByteBufferInputStream extends InputStream {
    ByteBuffer bb;

<span class="fc" id="L31">    public ByteBufferInputStream(ByteBuffer bb) {</span>
<span class="fc" id="L32">        this.bb = bb;</span>
<span class="fc" id="L33">    }</span>

    @Override
    public int read() throws IOException {
<span class="fc bfc" id="L37" title="All 2 branches covered.">        if (bb.remaining() == 0) {</span>
<span class="fc" id="L38">            return -1;</span>
        }
<span class="fc" id="L40">        return bb.get() &amp; 0xff;</span>
    }

    @Override
    public int available() throws IOException {
<span class="nc" id="L45">        return bb.remaining();</span>
    }

    @Override
    public int read(byte[] b, int off, int len) throws IOException {
<span class="pc bpc" id="L50" title="1 of 2 branches missed.">        if (bb.remaining() == 0) {</span>
<span class="nc" id="L51">            return -1;</span>
        }
<span class="pc bpc" id="L53" title="1 of 2 branches missed.">        if (len &gt; bb.remaining()) {</span>
<span class="nc" id="L54">            len = bb.remaining();</span>
        }
<span class="fc" id="L56">        bb.get(b, off, len);</span>
<span class="fc" id="L57">        return len;</span>
    }

    @Override
    public int read(byte[] b) throws IOException {
<span class="nc" id="L62">        return read(b, 0, b.length);</span>
    }

    @Override
    public long skip(long n) throws IOException {
<span class="nc" id="L67">        long newPos = bb.position() + n;</span>
<span class="nc bnc" id="L68" title="All 2 branches missed.">        if (newPos &gt; bb.remaining()) {</span>
<span class="nc" id="L69">            n = bb.remaining();</span>
        }
<span class="nc" id="L71">        bb.position(bb.position() + (int) n);</span>
<span class="nc" id="L72">        return n;</span>
    }

    static public void byteBuffer2Record(ByteBuffer bb, Record record)
            throws IOException {
        BinaryInputArchive ia;
<span class="fc" id="L78">        ia = BinaryInputArchive.getArchive(new ByteBufferInputStream(bb));</span>
<span class="fc" id="L79">        record.deserialize(ia, &quot;request&quot;);</span>
<span class="fc" id="L80">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>